************************************************************************
*PROCEDURE Call32Demo
********************
***  Modified: 12/04/95
***  Function: Example program for the Call32 functions
***    Assume: Call32.dll is available in local path or
***            Windows\system directory
*************************************************************************

*** Front end routines for Call32 Interface
SET PROCEDURE TO CALL32

SET LIBRARY TO home()+"FOXTOOLS" ADDITIVE
CLEAR

_WINNT=.F.
_WIN95=.T.
_WIN31=.F.


*** PLAIN W32 API CALL + Additional functions in DLL ***
IF .T.
   *** CALL WIN32 GetVersion()

   *** Register 32 Bit Function - returns function handle
   *** which is used when making the actual API call
   lhcall32=reg32("GetVersion","Kernel32.dll","")

   *** Set parameters and return type for the function
   *** Return RegFn()/CallFn() function handle.
   *** Note you always call Call32, using a different
   *** parameter list each time, depending on the function
   *** that is called.
   lhwinversion=RegFP("","L")

   *** Now use CallFn to call the Call32 function
   *** with the actual parameters plus the 32 bit handle
   lnversion=callfn(lhwinversion,lhcall32)
   ? "Win32 Getversion result (not decoded):",lnversion

   *** Bit shifting functions support function I put in Call32.dll

   *** Result is returned in a single LONG
   *** LoWord contains version, with low byte=minor
   *** HiByte=major
   lhconvert=regfn("LoWord","L","I")
   lhconvert2=regfn("LoByte","I","I")
   lhconvert3=regfn("HiByte","I","I")

   lnversion=callfn(lhconvert,lnversion)

   lnmajor=callfn(lhconvert2,lnversion)
   lnminor=callfn(lhconvert3,lnversion)
   ? "Win32 GetVersion (Converted Version):  Major ",lnmajor," - Minor ",lnminor
   
   *** Call 16 bit GetVersion
   lhWinVer=RegFn("GetVersion","","I")
   lnVersion= callfn(lhwinver)

   lnmajor=callfn(lhconvert2,lnversion)
   lnminor=callfn(lhconvert3,lnversion)
   ? "16 bit API Win Version:  Major ", lnMajor," Minor: ", lnMinor

   lhw32ver=regfn("W32Version","","I","call32.dll")

   ? "W32Version in Call32.dll:",callfn(lhw32ver)
   ?
   ?
ENDIF


*** SET FILE ATTRIBUTES EXAMPLE - Direct Win32 API access ***
IF .T.
   *** CALL WIN32 SetFileAttributes

   ***  BOOL SetFileAttributes(lpFileName, dwFileAttributes)
   ***
   ***  LPCTSTR lpFileName;	/* address of filename	*/
   ***  DWORD dwFileAttributes;	/* address of attributes to set	*/

   #DEFINE file_readonly	1
   #DEFINE file_hidden  	2
   #DEFINE file_system		4
   #DEFINE file_normal		128

   *** Register 32 bit function with the Call32 DLL interface
   lhcall32=reg32("SetFileAttributes","Kernel32.dll","pi")

   *** get a handle for use with Foxtools
   lhsetattr=RegFP("CL","L")

   MODI COMM test.txt

   *** Now actually call the 32 bit function
   =callfn(lhsetattr,"Test.txt",file_readonly,lhcall32)

   *** Note on this EDIT it'll say Read-Only
   MODI COMM test.txt
   =callfn(lhsetattr,"Test.txt",file_normal,lhcall32)
   MODI COMM test.txt
ENDIF


*** REGISTRY EXAMPLE -  Using RdRegStr/Int wrapper functions in Call32.DLL
*** Note this example set up for Windows NT
*** You'll need to change the registry paths for Win95
IF .T.
   IF _winnt
      *** Note this code calls a custom wrapper DLL function in CALL32 directly
      ?
      ? "32 bit Registry Example"
      ?

      lcroot="HKEY_CLASSES_ROOT"
      lcsubkey=".avi"
      lcvalue=""
      ? "Avi file type:",rdregstr(lcroot,lcsubkey,lcvalue)

*-*      lcroot="HKEY_CURRENT_USER"
*-*      lcsubkey="Printers"
*-*      lcvalue="Device"
*-*      ? "Printer Device:",rdregstr(lcroot,lcsubkey,lcvalue)

      lcroot="HKEY_LOCAL_MACHINE"
      lcsubkey="SOFTWARE\Microsoft\Windows NT\CurrentVersion\FontCache"
      lcvalue="MinInitSize"
      ? "Font Cache Id number (Integer):",rdregint(lcroot,lcsubkey,lcvalue)

      lcroot="HKEY_LOCAL_MACHINE"
      lcsubkey="SOFTWARE\Microsoft\Windows NT\CurrentVersion"
      lcvalue="CurrentVersion"
      ? "Windows NT Version from Registry:",rdregstr(lcroot,lcsubkey,lcvalue)
      ?
      ?


   ENDIF

   IF _win95
      lcroot="HKEY_LOCAL_MACHINE"
      lcsubkey="SOFTWARE\Classes\.avi"
      lcvalue=""
      ? "Avi file type:",rdregstr(lcroot,lcsubkey,lcvalue)

      lcroot="HKEY_CURRENT_USER"
      lcsubkey="RemoteAccess"
      lcvalue="AreaCode"
      ? "Remote Access Area Codes:",rdregstr(lcroot,lcsubkey,lcvalue)

      lcroot="HKEY_CURRENT_USER"
      lcsubkey="SOFTWARE\Microsoft\VisualFoxPro\3.0\Options"
      lcvalue="ResWidth"
      ? "VFP Form Resolution Width:",rdregstr(lcroot,lcsubkey,lcvalue)

      lcroot="HKEY_CURRENT_USER"
      lcsubkey="SOFTWARE\Netscape\Netscape Navigator\Tool Bar"
      lcvalue="Button Styles"
      ? "Netscape Toolbar Option (Integer):",rdregint(lcroot,lcsubkey,lcvalue)

      lcroot="HKEY_LOCAL_MACHINE"
      lcsubkey="SOFTWARE\Microsoft\Windows\CurrentVersion"
      lcvalue="VersionNumber"
      ? "Windows 95 Version from Registry:",rdregstr(lcroot,lcsubkey,lcvalue)

      lcroot="HKEY_CURRENT_USER"
      lcsubkey="SOFTWARE\Microsoft\Windows\CurrentVersion\Applets\Media Player\Options"
      lcvalue="SysIni"
      ? "Media Player SysIni Option (Integer):",rdregint(lcroot,lcsubkey,lcvalue)

      ?
      ?
   ENDIF
   

*** Read Write Demo
lcroot="HKEY_LOCAL_MACHINE"

IF _WIN95
  lcsubkey="SOFTWARE\Microsoft\Windows\CurrentVersion"
ELSE
  lcsubkey="SOFTWARE\Microsoft\Windows NT\CurrentVersion"
ENDIF
*** Must open the key first
lhreg=openkey(lcroot,lcsubkey)

lcOldSetting=querystr(lhreg,"RegisteredOwner")
? "Registered Owner: " + lcoldsetting

*-* Uncomment to actually check writing the registry!
*-*? "Setting Value: ", writestr(lhreg,"RegisteredOwner","New Owner")
*-*? "Showing New Value: ",querystr(lhreg,"RegisteredOwner")
*-*? "Rewriting old value: ", writestr(lhreg,"RegisteredOwner",lcOldSetting)
*-*? "Showing Old Value: ",querystr(lhreg,"RegisteredOwner")

*** Don't forget to close the key
=closekey(lhreg)

ENDIF


CLEAR ALL
SET LIBRARY TO

